/**
 * Boilerplate code required to hook into the ADTECH rich media library.
 *
 * For API documentation, please contact canvas-help@adtech.com
 
 */
adtechAdConfig.assetContainers.main.isExpandable = true;
(function(adConfig) {
  var requiresBreakout = false;
  var targetIsFriendly = false;
	
	 if(adConfig.pubVars && adConfig.pubVars.clickRedirect){
		//adConfig.pubVars.clickRedirect = unescape(adConfig.pubVars.clickRedirect);
	}
	if(adConfig.pubVars.clickRedirect && adConfig.pubVars.clickRedirect.length>0 && adConfig.clickthroughs.main && adConfig.clickthroughs.main.dest){
		var adnxClkTests = [/https:\/\/console\.appnexus\.com\/creative\/click-redir\/\+d\?click=/,/https%3A%2F%2Fconsole\.appnexus\.com%2Fcreative%2Fclick-redir%2F\d+%3Fclick%3D/];
		var shouldAddExtraEncode = false;
		for(var i=0;i<adnxClkTests.length;i++){
			if(adConfig.pubVars.clickRedirect.match(adnxClkTests[i])){
				shouldAddExtraEncode = true;
				break;
			}
		}
		if(shouldAddExtraEncode){
			adConfig.clickthroughs.main.dest = escape(adConfig.clickthroughs.main.dest);
		}
	}

	if(location.href.match(/(?:console-)?ib\.adnxs\.com|audit(?:-groupie)?\.adnxs\.net|(?:console\.)?appnexus\.com|googleadservices\.com|(.*)\.googleusercontent\.com|onecreative\.aol\.com|creative-preview-an\.com|cq-preview\.adnxs\.net/)){
		adtechCanvasAdPreview = true;
	}
	
	
  // Attempt to break out only in a non-MRAID environment.
  if (!window.mraid) {
    // Check for global property to set the target display window creative override.
    // This is used by the CRAFT Preview Service.
    if (typeof window.adtechDisplayWindowTarget === 'object') {
      adConfig.overrides = adConfig.overrides || {};
      adConfig.overrides.displayWindowTarget = window.adtechDisplayWindowTarget;
    }

    if (!adConfig.overrides || adConfig.overrides.displayWindowTarget != self) {
      for (var id in adConfig.assetContainers) {
        if (adConfig.assetContainers.hasOwnProperty(id)) {
          var container = adConfig.assetContainers[id];
          if (container.type != 'inlineDiv' || container.isExpandable) {
            requiresBreakout = true;
            break;
          }
        }
      }
    }

    if (adConfig.overrides && adConfig.overrides.displayWindowTarget) {
      var displayWindowTarget = adConfig.overrides.displayWindowTarget;
      displayWindowTarget = (typeof adtechIframeHashArray != 'undefined' && self != top) ?
          displayWindowTarget.parent : displayWindowTarget;
    } else {
      var calculatedTarget = null;
      var currentWindow = parent;
      while (currentWindow != undefined) {
        try {
          var targetDoc = currentWindow.document;
          if (targetDoc) {
            calculatedTarget = currentWindow;
          }
        } catch (e) {
        }
        currentWindow = (currentWindow == top) ? null : currentWindow.parent;
      }
      var displayWindowTarget = calculatedTarget || top;
    }

    try {
      var targetDoc = displayWindowTarget.document;
      if (targetDoc) {
        targetIsFriendly = true;
      }
    } catch (e) {
    }
  }

  var targetWindow = (requiresBreakout && (self != top && targetIsFriendly)) ?
      displayWindowTarget : self;

  targetWindow.com = targetWindow.com || {};
  targetWindow.com.adtech = targetWindow.com.adtech || {};
  var win = targetWindow, doc=win.document;

  targetWindow.com.adtech.AdtechCustomAd$AD_ID$ = function() {
    // Custom code class constructor.
  };

  targetWindow.com.adtech.AdtechCustomAd$AD_ID$.prototype = {

    /**
     * Entry point methods.
     *
     * Automatically invoked by the rich media library when the library API is
     * available to use, and the Advert instance has been instantiated.
     */
    preInit: function() {
      window.com = com || {};
      com.adtech = targetWindow.com.adtech;
    },

        init: function(advert) {
      if (!advert.richView) {
        advert.dispatchEvent('close');
        // The backup client can not render the rich version of the advert.
        return;
      }
            
      // A few useful things to help you get started. Please delete as necessary!
      this.advert = advert;
      this.container = this.advert.getAssetContainer("main");
    	this.utils = com.adtech.Utils_$VERSION$;
      this.globalEventBus = targetWindow.adtechAdManager_$VERSION$.globalEventBus;
      this.richMediaEvent = com.adtech.RichMediaEvent_$VERSION$;
			this.advert.eventBus.addEventListener("close2", this.utils.createClosure(this, this.closeHandler));
			this.advert.eventBus.addEventListener("close3", this.utils.createClosure(this, this.closeHandler));
      
      

      /*
       * This is how you listen for your custom events.
       * ADTECH.close() is actually just an alias of ADTECH.event('close').
       */
      advert.eventBus.addEventListener('close',
          this.utils.createClosure(this, this.closeHandler));
					
      advert.eventBus.addEventListener('autoClose',
          this.utils.createClosure(this, this.closeHandler));		
					
      if (this.container.rendered) {
      this.renderHandler();
    	} else {
      	this.container.addEventListener('render', this.utils.createClosure(this, this.renderHandler));
    	}


      /*
       * Want to wait until the DOM or the page has loaded? No problem!
       */
      if (this.globalEventBus.pageLoaded) {
        this.pageLoadHandler();
      } else {
        this.globalEventBus.addEventListener(this.richMediaEvent.PAGE_LOAD,
            this.utils.createClosure(this, this.pageLoadHandler));
      }
      this.globalEventBus.addEventListener(this.richMediaEvent.PAGE_RESIZE,
            this.utils.createClosure(this, this.handleResize));
    },

    /*********************************************************
     *
     * Create your instance methods below.
     *
     * Please remember not to add a trailing comma to you last
     * method - IE will not like that!
     *
     *********************************************************/
		closeHandler: function() {
     var Q = d = doc;
            var O = Q.documentElement;
            var M = d.body;
            //var R = M.appendChild(Q.createElement("span"));
            //R.style.color = "red";
            try {
              //  R.innerHTML = "close1 " + window.mraid.getState()
            }
            catch (P) {}
            if(!!window.mraid){
            try {
                mraid.close()
            }
            catch (P) {}
            var N = setInterval(function() {
                try {
                    //R = M.appendChild(Q.createElement("span"));
                    //R.style.color = "red";
                    //M.innerHTML = "close2 " + window.mraid.getState() + " " + mraid.close + "<br/>";
                    if (!(window.mraid.getState() == "default" || window.mraid.getState() == "expanded" || window.mraid.getState() == "resized")) {
                        clearInterval(N);                    }
                    else {
                        mraid.close()
                    }
                }
                catch (S) {}
            },
            50);
          }
            this.advert.close();
            this.container.close();
            /*O.style.display = "none";
            M.style.display = "none";
            O.style.backgroundColor = "transparent";
            M.style.backgroundColor = "transparent";*/
            O.style.overflow = "auto";
            M.style.overflow = "auto";
    },
		renderHandler: function() {
       var t = this;
       var d = doc;
       var b = d.body;
       var h = d.documentElement;
     
       if(adConfig.mraidCompatible){
       	b.style.width = '100%';       
       	b.style.height = '100%';
       	h.style.width = '100%';       
       	h.style.height = '100%';
       	this.advert.reportEvent('mraidIsVisible');
       }else{
       	this.handleResize();
       }
       var del = function(){
				 t.container.anchorDiv.style.display = 'inline-block';
         /*t.container.anchorDiv.style.right = '0px';       
         t.container.anchorDiv.style.bottom = '0px';*/
         t.container.anchorDiv.style.width = 0;       
         t.container.anchorDiv.style.height = 0;
         t.container.anchorDiv.style.left = '0px';
         t.container.anchorDiv.style.top = '0px';
         t.container.div.style.width = '100%';
				 t.container.div.style.top = '0px';
				 t.container.div.style.left = '0px';
				 t.container.div.style.position = 'fixed';
				 t.container.div.style.zIndex = 0xFFFFFFF;
				 t.container.div.style.clip = 'unset';
         t.container.div.style.height = '100%';
         t.container.content.contentObject.width = '100%';
         t.container.content.contentObject.height = '100%';
         t.container.content.contentObject.style.width = '100%';
         t.container.content.contentObject.style.height = '100%';         
         
				 if(!adConfig.mraidCompatible){
         	t.container.anchorDiv.style.zIndex = 0xFFFFFFFF;
         	if(t.utils.canUseFixedPositioning())
         		t.container.anchorDiv.style.position = 'fixed';
         	win.scrollTo(0,0);
         	b.style.overflow = 'hidden';
         	h.style.overflow = 'hidden';
         	t.handleResize();
         	var xdel = function(){
         		t.handleResize();;
         	}
         /*	xdel();
         	for(var i=0;i<1200;i+=3){
         		setTimeout(xdel,i+10);
         	}
         	setTimeout(xdel,25);
         	setTimeout(xdel,50);
         	setTimeout(xdel,100);
         	setTimeout(xdel,150);
         	setTimeout(xdel,250);
         	setTimeout(xdel,1000);*/
        	}
       };
       del();
       //setTimeout(del,50);
       //setTimeout(del,150);


     },
    pageLoadHandler: function() {
      // The page has now loaded. Feel free to display an awesome advert.
    },
		handleResize:function(){
			
		}
  };

  targetWindow.adtechCallbackInstances = targetWindow.adtechCallbackInstances || [];
  var instanceIndex = targetWindow.adtechCallbackInstances.length;
  targetWindow.adtechCallbackInstances[instanceIndex] =
      new targetWindow.com.adtech.AdtechCustomAd$AD_ID$();

  targetWindow.adtechAdCallbacks = targetWindow.adtechAdCallbacks || {};
  targetWindow.adtechAdCallbacks[adConfig.adServerVars.uid] =
      targetWindow.adtechAdCallbacks[adConfig.adServerVars.uid] || [];
  targetWindow.adtechAdCallbacks[adConfig.adServerVars.uid].push(
      targetWindow.adtechCallbackInstances[instanceIndex]);
})(adtechAdConfig);
